/*
 * plcsrvthread.h
 *	 
 */ 

#ifndef PLCSRVTHREAD_H
#define PLCSRVTHREAD_H

#include <omnithread.h>
#include <tango.h>
#include <stdio.h>
#include <errno.h>   

#include <PLCRack3.h>


//size of the message buffer
#define	BUF_LEN	200000

namespace PLCRack3_ns{

class plcsrvthread : public omni_thread, public Tango::LogAdapter{
	
	private:
		PLCRack3 *t_PLCRack3;
		bool db20_received;
		bool db24_received;
				
	public:
		
		plcsrvthread(PLCRack3 *s):Tango::LogAdapter(s){
			t_PLCRack3 = s;

			first_mesg = true;
			db20_received = false;
			db24_received = false;
		};
		
		~plcsrvthread() {
		};
//		void *StartUndetached(){
//			start_undetached();
//		}
//		void *run_undetached(void *);	

	protected:
		void run(void *);	
	
		int errcount;
		struct timeval last_read;
		char frame2[BUF_LEN];
		u_short olddata;
	//	tstamp_t time_before;
	//	intlck_db53 lastmsg;

		Tango::DeviceProxy *mydevice;
		Tango::DeviceAttribute arl;
	
	//	logalarm_t local_mesg;
	
		int cnt, cnt2, server_started;
		bool first_mesg;  

   	//	struct sembuf operations[1];
		int retval;
		int id;

		//char buf[BUF_LEN];
		char *buf;
		unsigned long push_counter;
		bool allow_push;

		void Srv_Prepare(void);
		uint16_t plc_swap(uint16_t in);
		uint32_t plc_swaplong(uint32_t in);
		void parse_message(uint16_t type, uint16_t size);

//		long ll, mm;
		u_short v;
		int brk;

		int idx;

		float ntohf(float val_f);
		float htonf(float val_f);
};	/* end class plcsrvthread() */

}//	namespace 

#endif

/* EOF */
